<?php

define('PUN_PLUGIN_LOADED', 1);

class MyDBLayer extends DBLayer {
  
	function fetch_rowset($query)
	{
        $rowset = array();
		$result = $this->query($query);
        while ($row = $this->fetch_assoc($result)) $rowset[] = $row;
		
        return $rowset;
	}
	
	function get_value($query)
	{
		$result = $this->query($query);
		$row = $this->fetch_row($result);
		
		return $row[0];	
	}
}

$pun_db =& $db;

// Display the admin navigation menu
generate_admin_menu($plugin);

if (isset($_POST['step2'])) {
	if  ($_GET['type'] == 'auto') {
		@include $_POST['path_to_file'];
		if (!isset($CONFIG)) {
			message('Failed to read config at location');
		}
	} elseif ($_GET['type'] =='manual') {
		$CONFIG['dbserver'] = $_POST['server_name'];
		$CONFIG['dbuser'] = $_POST['db_user'];
		$CONFIG['dbpass'] = $_POST['db_pass'];
		$CONFIG['dbname'] = $_POST['db_name'];
		$CONFIG['TABLE_PREFIX'] = $_POST['db_prefix'];
	} else {
		message('invalid type');
	}
	
	$CONFIG['TABLE_USERS'] = $CONFIG['TABLE_PREFIX'] . 'users';
	$CONFIG['TABLE_CONFIG'] = $CONFIG['TABLE_PREFIX'] . 'config';
	$CONFIG['TABLE_USERGROUPS'] = $CONFIG['TABLE_PREFIX'] . 'usergroups';
	$CONFIG['TABLE_PICTURES'] = $CONFIG['TABLE_PREFIX'] . 'pictures';
	$CONFIG['TABLE_COMMENTS'] = $CONFIG['TABLE_PREFIX'] . 'comments';
	$CONFIG['TABLE_ALBUMS'] = $CONFIG['TABLE_PREFIX'] . 'albums';
	$CONFIG['version'] = $_POST['version'];
			
	$cpg_db =  new MyDBLayer($CONFIG['dbserver'], $CONFIG['dbuser'] , $CONFIG['dbpass'], $CONFIG['dbname'], '' , false);
	$users = $cpg_db->get_value("SELECT COUNT(*) FROM {$CONFIG['TABLE_USERS']} WHERE 1");
	$groups = $cpg_db->fetch_rowset("SELECT * FROM {$CONFIG['TABLE_USERGROUPS']} WHERE 1");
	
?>

	<div id="exampleplugin" class="blockform">
		<h2><span>Coppermine Importer</span></h2>
		<div class="box">
			<div class="inbox">
				<p>Found <? echo $users ? $users : '0'; ?> users to import.</p>
			</div>
		</div>

		<h2 class="block2"><span>Step 2 - Group Mapping</span></h2>
		<div class="box">
			<form id="mapping" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
						<legend>Group mapping:</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
						<tr>
							<th scope="row">Coppermine groups</th>
							<td>Punbb group to map to - </td>
						</tr>
<?php

function make_dd($id)
{
	global $pun_db;

	$result = $pun_db->query('SELECT g_id, g_title FROM '.$pun_db->prefix.'groups ORDER BY g_title') or message('Failed to load punbb groupies', __FILE__, __LINE__, $pun_db->error());

	$dropdown =  '<select name="groups['.$id.']">';
	
	while ($cur_group = $pun_db->fetch_assoc($result))
		$dropdown .= '<option value="'.$cur_group['g_id'].'">'.pun_htmlspecialchars($cur_group['g_title']).'</option>'."\n";
	
	$dropdown .= '</select>';

	return $dropdown;
}

foreach ($groups as $group){
	echo '<tr><th scope="row">'.$group['group_name'].' </th><td>'.make_dd($group['group_id']).'</td></tr>';
}

$conn = base64_encode(serialize($CONFIG));

?>
								<th scope="row">
									<input type="hidden" name="data" value="<? echo $conn; ?>" />
									<input type="submit" name="step3" value="Next >>" tabindex="2" />
								</th>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
			</form>
		</div>
	</div>
<?

} elseif (isset($_POST['step3'])) {
	
	$CONFIG = unserialize(base64_decode($_POST['data']));	
	$cpg_db =  new MyDBLayer($CONFIG['dbserver'], $CONFIG['dbuser'] , $CONFIG['dbpass'], $CONFIG['dbname'], '' , false);
	
	$conn = base64_encode(serialize($CONFIG));
	$grps = base64_encode(serialize($_POST['groups']));
	
	$users = $cpg_db->get_value("SELECT COUNT(*) FROM {$CONFIG['TABLE_USERS']} WHERE 1");

	?> 
	<div id="exampleplugin" class="blockform">
		<h2><span>Coppermine Importer</span></h2>
		<div class="box">
			<div class="inbox">
				<p>Coppermine user importer version 0.1a</p>
			</div>
		</div>
		
		<h2 class="block2"><span>Step 3 - Settings</span></h2>
		<div class="box">
			<form id="conv" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
					<?
					if ($CONFIG['version'] == '1.3') {
					echo <<< EOT
						<legend>Non-transferrables !</legend>
						<div class="infldset">
							<table class="aligntop" cellspacing="0">
								<tr>
									<th scope="row">
										Note: The following information will NOT be retained: interests, occupation !
									</th>
								</tr>
							</table>
						</div>
					</fieldset>
				</div>
EOT;
				} elseif ($CONFIG['version'] == '1.4'){
					
				echo <<< EOT
					<legend>Profile mapping !</legend>
						<div class="infldset">
							<table class="aligntop" cellspacing="0">
						<tr>
							<th scope="row">Coppermine profile fields</th>
							<td>Punbb profile fields to map to - </td>
						</tr>
EOT;

function make_dd($id)
{
	global $pun_db;
	
	$dropdown =  '<select name="profile['.$id.']">';
	
	
	$result = $pun_db->query("SHOW COLUMNS FROM {$pun_db->prefix}users");

	while ($row = $pun_db->fetch_assoc($result)) {
	
	$dropdown .= '<option value="'.$row['Field'].'">'.$row['Field']. '&nbsp;&nbsp;&nbsp;' . $row['Type'] . '</option>'."\n";
	
	}
	
	$dropdown .= '<option value="blackhole">[abandon this data]</option>'."\n";
	
		
	$dropdown .= '</select>';

	return $dropdown;
}

$result = $cpg_db->query("SHOW COLUMNS FROM {$CONFIG['TABLE_USERS']} LIKE 'user_profile%'");

$lookup_q = $cpg_db->query("SELECT * FROM {$CONFIG['TABLE_CONFIG']} WHERE name LIKE 'user_profile%'");

$lookup = array();
while ($inf = $cpg_db->fetch_assoc($lookup_q)) {
	$lookup[$inf['name']] = $inf['value'];
}

while ($row = $pun_db->fetch_assoc($result)) {
	
	$name = $lookup[$row['Field'].'_name'] ? $lookup[$row['Field'].'_name'] : 'Un-named field';
	
	echo '<tr><th scope="row">'.$name.'</th><td>'.make_dd($row['Field']).'<span><i>'.$name.' </i>is a '. $row['Type'] .' type field</span></td></tr>';

}



$conn = base64_encode(serialize($CONFIG));
echo <<< EOT
									</th>
								</tr>
							</table>
						</div>
					</fieldset>
				</div>
EOT;
					
					
					} else {
						message('Unknown version!');
						}
						?>
				<div class="inform">
					<fieldset>
						<legend>Conversion settings:</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row">Number of users to convert per click</th>
								<td>
									<input name="users_per_click" size="5" value="100" type="text" tabindex="1" >
									<input type="hidden" name="data" value="<? echo $conn; ?>" />
									<input type="hidden" name="groups" value="<? echo $grps; ?>" />
									<span>Conversion happens in batches to avoid timeouts and spiking server load. (<? echo $users; ?> users in total)</span>
								</td>
							</tr>
								<tr>
								<th scope="row">Retain user relationships</th>
								<td>
									<input name="retain_inf" value="1" type="radio">&nbsp;<strong>Yes</strong>&nbsp;&nbsp;&nbsp;									<input name="retain_inf" value="0" checked="checked" type="radio">&nbsp;<strong>No</strong>
									<span>Retains a user's ownership of his/her files and comments. This requires <i>UPDATE</i> permissions on the coppermine database. backup your coppermine db if you plan to do this.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Attach admin note</th>
								<td>
									<input name="admin_note" size="50" value="converted from cpg <? echo date('Y-m-d') ?>" type="text" tabindex="1" >
									<span>Attach a custom admin note to denote users which have undergone conversion. (30 characters max)</span>
								</td>
							</tr>
							
						</table>
						</div>
					</fieldset>
				</div>
				<input type="submit" name="step4" value="Next >>" tabindex="2" />
			</form>
		</div>
	</div>
<?
} elseif (isset($_POST['step4'])) {

	$CONFIG = unserialize(base64_decode($_POST['data']));
	$grps = unserialize(base64_decode($_POST['groups']));
	$cpg_db =  new MyDBLayer($CONFIG['dbserver'], $CONFIG['dbuser'] , $CONFIG['dbpass'], $CONFIG['dbname'], '' , false);
	
?>

	<div id="exampleplugin" class="blockform">
		<h2><span>Coppermine Importer</span></h2>
		<div class="box">
			<div class="inbox">
				<p>Coppermine user importer version 0.1a</p>
			</div>
		</div>

		<h2 class="block2"><span>Step 4 - User conversion</span></h2>
		<div class="box">
			<form id="loc_manual" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
						<legend>Users converted</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
<?

function row($a, $b)
{
echo <<< EOT
							<tr>
								<th scope="row">$a</th>
								<td>
									$b
								</td>
							</tr>
EOT;
}

if (isset($_POST['retain_inf']) && $_POST['retain_inf'] == 1){
	$comments = $cpg_db->query("UPDATE {$CONFIG['TABLE_COMMENTS']} SET author_id = -author_id WHERE 1");
	$files = $cpg_db->query("UPDATE {$CONFIG['TABLE_PICTURES']} SET owner_id = -owner_id WHERE 1");
	$user_gals_vis_grp = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET visibility = -visibility WHERE visibility < 10000");
	$user_gals_vis = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET visibility = -visibility WHERE visibility > 10000");
	$user_gals_cat = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET category = -category WHERE category > 10000");
		
		row('Table inversion - comments', $comments ? 'complete' : 'failed');
		row('Table inversion - files', $files ? 'complete' : 'failed');
		row('Table inversion - user galleries owner visibility', $user_gals_vis ? 'complete' : 'failed');
		row('Table inversion - user galleries group visibility', $user_gals_vis_grp ? 'complete' : 'failed');
		row('Table inversion - user galleries ownership', $user_gals_cat ? 'complete' : 'failed');

		$_POST['retain_inf_ongoing'] = 1; // :P
}



if (isset($_POST['admin_note'])){
	$adm_note = ", '" . $_POST['admin_note'] . "'";
	$adm_note_inc = ", admin_note";
} else {
	$adm_note = '';
	$adm_note_inc = '';
}	
	
$start = isset($_POST['start']) ? $_POST['start'] : 0;
$number = $_POST['users_per_click'];

$collect = $cpg_db->query("SELECT * FROM {$CONFIG['TABLE_USERS']} LIMIT $start, $number");

while ($row = $cpg_db->fetch_assoc($collect)){
	
	 extract($row);
	
	$user_group_new = $grps[$user_group];
	$user_password = pun_hash($user_password);
	
	if ($CONFIG['version'] == '1.3') {
		$sql = "INSERT INTO ".$pun_db->prefix."users (group_id, username, password, email, url, location, registered, last_visit $adm_note_inc) VALUES ($user_group_new, '$user_name', '$user_password', '$user_email', '$user_website', '$user_location', UNIX_TIMESTAMP('$user_regdate'), UNIX_TIMESTAMP('$user_lastvisit') $adm_note)";
	} elseif ($CONFIG['version'] == '1.4') {
		$prof_conv = array();
		$prof_inf = array();
		
		foreach ($_POST['profile'] as $field => $value)
			if ($value != 'blackhole'){
				$prof_conv[] = $value;
				$prof_inf[] = "'".$$field."'";
			}
			
		$profile_names = ', ' . implode(', ', $prof_conv);		
		$profile_data = ', ' . implode(', ', $prof_inf);
		
		$sql = "INSERT INTO ".$pun_db->prefix."users (group_id, username, password, email, registered, last_visit $adm_note_inc $profile_names) VALUES ($user_group_new, '$user_name', '$user_password', '$user_email', UNIX_TIMESTAMP('$user_regdate'), UNIX_TIMESTAMP('$user_lastvisit') $adm_note $profile_data)";
	} else {
		message('Unknown version');
	}
	
	$insert = $pun_db->query($sql);
	
	row($user_name, $insert ? 'inserted' : 'insert failed');
	
if ((isset($_POST['retain_inf_ongoing']) && $_POST['retain_inf_ongoing'] == 1)){

	$insert_id = $pun_db->insert_id();
	
	$upd_com = $cpg_db->query("UPDATE {$CONFIG['TABLE_COMMENTS']} SET author_id = $insert_id WHERE author_id = -$user_id");
	$upd_com_num = $cpg_db->affected_rows();
	
	$upd_files = $cpg_db->query("UPDATE {$CONFIG['TABLE_PICTURES']} SET owner_id = $insert_id WHERE owner_id = -$user_id");
	$upd_files_num = $cpg_db->affected_rows();
	
	$upd_user_gals_vis_grp = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET visibility = 10000 + $insert_id WHERE visibility = -(10000 + $user_id)");
	$upd_user_gals_vis_grp_num = $cpg_db->affected_rows();
	
	$upd_user_gals_vis = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET visibility = $user_group_new WHERE visibility = -$user_group");
	$upd_user_gals_vis_num = $cpg_db->affected_rows();
	
	$upd_user_gals_cat = $cpg_db->query("UPDATE {$CONFIG['TABLE_ALBUMS']} SET category = 10000 + $insert_id WHERE category = -(10000 + $user_id)");
	$upd_user_gals_cat_num = $cpg_db->affected_rows();
		
	$stra = array('Updated');
	
	if ($upd_com_num) $stra[] = "$upd_com_num comments";
	if ($upd_files_num) $stra[] = "$upd_files_num files";
	if ($upd_user_gals_vis_grp_num) $stra[] =  "$upd_user_gals_vis_grp_num group visibility settings";
	if ($upd_user_gals_vis_num) $stra[] = "$upd_user_gals_vis_num user visibility settings";
	if ($upd_user_gals_cat_num)  $stra[] = "$upd_user_gals_cat_num album ownership settings";
	
	if (count($stra) == 1){
		$str = 'Nothing to update';
	} else {
		$str = implode(', ', $stra);
	}
	row($user_name, $str);
}

}
$start += $number;
$num_actual = $cpg_db->num_rows($collect);

$conn = base64_encode(serialize($CONFIG));
$grps = base64_encode(serialize($grps));

?>

						</table>
						<input type="hidden" name = "start" value="<? echo $start; ?>" />
						<input type="hidden" name = "users_per_click" value="<? echo $number; ?>" />
						<input type="hidden" name="data" value="<? echo $conn; ?>" />
						<input type="hidden" name="groups" value="<? echo $grps; ?>" />
						<?
							if ($num_actual == $number) 
								echo '<input type="submit" name="step4" value="Next >>" tabindex="2" />';
							else echo 'completed :o)';
						?>
						<input type="hidden" name = "retain_inf_ongoing" value="<? echo $_POST['retain_inf']; ?>" />
						</div>
					</fieldset>
				</div>
			</form>
		</div>
	</div>
<?
} else {
?>
	<div id="exampleplugin" class="blockform">
		<h2><span>Coppermine Importer</span></h2>
		<div class="box">
			<div class="inbox">
				<p>Coppermine user importer version 0.1a</p>
			</div>
		</div>

		<h2 class="block2"><span>Step 1 - Authentication</span></h2>
		<div class="box">
			<form id="loc_path" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>&amp;type=auto">
				<div class="inform">
					<fieldset>
						<legend>Read from config file:</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row">Path to config.inc.php file:</th>
								<td>
									<input name="path_to_file" size="50" value="../coppermine/include/config.inc.php" type="text" tabindex="1" >
									<span>The path to coppermine's configuration file.</span>
								</td>
							</tr>
								<tr>
								<th scope="row">Coppermine version</th>
								<td>
									<input name="version" value="1.3" checked="checked" type="radio">&nbsp;<strong>1.3.x</strong>&nbsp;&nbsp;&nbsp;									<input name="version" value="1.4"  type="radio">&nbsp;<strong>1.4.x<strong>
									<span>The version of coppermine you are importing from. If your version is not listed it is not supported.</span>
								</td>
							</tr>
														<tr>
								<th scope="row">
									<input type="submit" name="step2" value="Next >>" tabindex="2" />
								</th>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
			</form>
			
			<form id="loc_manual" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>&amp;type=manual">
				<div class="inform">
					<fieldset>
						<legend>Enter info manually:</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row">Server Name</th>
								<td>
									<input name="server_name" size="50" value="localhost" type="text" tabindex="3" >
									<span>The name of the server on which your MySQL databse resides.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Database name</th>
								<td>
									<input name="db_name" size="50" type="text" tabindex="4" >
									<span>The name of the database containing coppermine.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Database user</th>
								<td>
									<input name="db_user" size="50" type="text" tabindex="5" >
									<span>The username to use to connect to the database (needs <i>SELECT</i> access only)</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Database password</th>
								<td>
									<input name="db_pass" size="50" type="text" tabindex="6" >
									<span>The password associated with the above username.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Tablename prefix</th>
								<td>
									<input name="db_prefix" size="50" type="text" value="cpg_" tabindex="7">
									<span>The prefix for coppermine's tables.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Coppermine version</th>
								<td>
									<input name="version" value="1.3" checked="checked" type="radio">&nbsp;<strong>1.3.x</strong>&nbsp;&nbsp;&nbsp;									<input name="version" value="1.4"  type="radio">&nbsp;<strong>1.4.x<strong>
									<span>The version of coppermine you are importing from. If your version is not listed it is not supported.</span>
								</td>
							</tr>
							<tr align="right">
								<th scope="row" align="right">
									<input type="submit" name="step2" value="Next >>" tabindex="8" />
								</th>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
			</form>
		</div>
	</div>
<?php

}

// Note that the script just ends here. The footer will be included by admin_loader.php.